<script setup>
import { computed } from "vue";
import { ref } from "vue";

const props = defineProps({
  comments: { type: Array, required: true },
});
const emit = defineEmits(["updateComment", "deleteComment", "cancel"]);
defineExpose({ triggerAddComment, triggerUnfold });

const isUnfold = ref(false);
const addComment = ref(false);
const newComment = ref(null);

function triggerAddComment() {
  addComment.value = true;
  isUnfold.value = true;
}

function triggerUnfold() {
  isUnfold.value = true;
}

const color = computed(() => (props.comments.some(Boolean) ? "black" : undefined));
</script>

<template>
  <div :class="['dropdown', isUnfold ? 'is-active' : '']">
    <!-- ICON ANCHOR/TRIGGER FOR DROPDOWN -->
    <div class="dropdown-trigger ml-1 mr-1 is-flex">
      <Icon :icon="'message-square'" :fill="color" :tooltip="comments?.[0]" @click="triggerUnfold()" />
    </div>

    <div class="dropdown-menu p-0">
      <div class="dropdown-content p-1 pt-2 has-border">
        <!-- DROPDOWN ITEMS LOOP -->
        <div v-for="(comment, index) in comments" :key="'comment-' + index">
          <div class="is-relative dropdown-item p-1">
            <!-- COMMENT TEXTAREA -->
            <textarea
              class="textarea p-1"
              rows="3"
              :value="comment"
              @mousedown.stop
              @change="emit('updateComment', index, $event.target.value)"
            />
            <!-- DELETE COMMENT ICON -->
            <Icon
              class="mt-1 mr-2"
              style="position: absolute; right: 0px; top: 0px"
              :icon="'trash-2'"
              @click="emit('deleteComment', index)"
            />
          </div>
          <hr v-if="comments.length > 1 && index < comments.length - 1" class="dropdown-divider" />
        </div>
        <div class="dropdown-item p-1">
          <div v-if="addComment">
            <!-- NEW COMMENT TEXTAREA -->
            <textarea v-model="newComment" class="textarea p-1" rows="3" @mousedown.stop />
            <!-- NEW COMMENT BUTTONS -->
            <div class="field is-grouped mt-2">
              <p class="control">
                <a
                  class="button"
                  @click="
                    emit('updateComment', -1, newComment);
                    isUnfold = false;
                    addComment = false;
                    newComment = '';
                  "
                >
                  Save
                </a>
              </p>
              <p class="control">
                <a
                  class="button"
                  @click="
                    emit('cancel');
                    addComment = false;
                    isUnfold = false;
                  "
                >
                  Cancel
                </a>
              </p>
            </div>
          </div>
          <!-- GENERAL COMMENT BUTTONS -->
          <div v-else class="field is-grouped mb-1">
            <p class="control">
              <a class="button" @click="addComment = true">Add Comment</a>
            </p>
            <p class="control">
              <a
                class="button"
                @click="
                  isUnfold = false;
                  emit('cancel');
                "
              >
                Close
              </a>
            </p>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
